#    Amazing Text Fun Game Engine - a engine for the decoding and play of .atf game files
#    Copyright (C) <2002>  <Kenneth Bromberg, Antoni Chan>
#    See README for full license information

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Questions or comments?  Contact the author - atfengine@alltooflat.com

require Exporter;
@ISA = qw(Exporter);
@Export = qw(ParseCommand, ExecuteVerbCodeI);




# PARSECOMMAND($commandline) - Woof.  This is where the magic happens.
#
#  Note: Maybe we should strip articles (a, the) from the commandline?
sub ParseCommand 
{
	my $verb;

	$commandline = shift;

	$commandline =~ tr/[A-Z]/[a-z]/;		# make command input all lowercase
	$commandline =~ s/\.//;					# remove any "." from command input

	my @splitline = split(/\s/, $commandline);
	@splitcommand = @splitline;		#  Split command is the backup of the segmented commandline.
									#  We use remove items from @splitline, and I don't want them lost
	
	my @objects;

	do
	{
		($verb, @splitline) = @splitline;

		$VerbCode = &DecodeVerb($verb, \@splitline);
	}	until( !($VerbCode eq -1));


	#  Decided on having three different functions for enacting the three different types of functions
	#  Probably not the best idea I've ever had, but it should work.  And it'll keep the code more readable, i think.
	if ($VerbCode =~ /^0/) 
	{
		$VerbCode =~ s/^0//;			#  Strip the preceding digit away from the VERBCODE
		&ExecuteVerbCode0($VerbCode);
	}
	elsif ($VerbCode =~ /^1/)
	{
		$VerbCode =~ s/^1//;
		@objects =&GetItemsFromCommand(\@splitline);
		&ExecuteVerbCode1($VerbCode, \@objects);

	}
	elsif ($VerbCode =~ /^2/)
	{
		$VerbCode =~ s/^2//;
		@objects =&GetItemsFromCommand(\@splitline);
		&ExecuteVerbCode2($VerbCode, \@objects);
	}

	elsif ($VerbCode =~ /^t/)	# A "type" or "write" command
	{
		$VerbCode =~ s/^t//;
		unshift(@splitline, "typetype");
		@objects = &GetItemsFromCommand(\@splitline);	# @OBJECTS will contain only the first item (if any) in the command line
		if (scalar(@objects) eq 0) 
		{
			push(@objects, "no item");
		}
		shift(@splitline);		# Removes "typetype" from splitline
		&ExecuteVerbCodeT($VerbCode, $objects[0], \@splitline);		# We only have to feed EVCT the single object found in the command line
	}

	elsif ($VerbCode eq "-2")
	{
		print "I'm afraid I don't understand.";
	}

	# For when you want to return from a verbcode execution and not print anything out (e.g. when loading or saving a game)
	elsif ($VerbCode eq "-3")
	{
	}
	$lastcommand = $commandline;
}

# EXECUTEVERBCODE2($VERBCODE, $OBJECTLIST) - Actually performs the actions specified by the input VERBCODE and list of objects
#
sub ExecuteVerbCode2
{
	my $VerbIn = shift;
	my $items = shift;
	my $thang;
	my $aretwoitems = 1;

	if ( (scalar(@$items) ne 2) )
	{
		$aretwoitems = 0;
	}



	$ObjectNum1 = $ItemtoNumHash{@$items[0]};
	$ObjectNum2 = $ItemtoNumHash{@$items[1]};

	if ( ($VerbIn eq 'use') )	# This is the "USE ITEM ON ITEM" code
	{
		if (!($aretwoitems))	# If there are not two objects in the item list
		{
			print "Use @$items[0] on what?  Please retry command";
		}
		elsif( ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) and ( $Player->CheckIfItem($ObjectNum2) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum2)) )
		{
			my $sendtoitemcode = $VerbIn.$ObjectNum2;	# The code we send to the item for 
														#	decoding is the Verb+the object it's used on
						
			if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
			{
				print " pened.\n";
			}
		}
		else
		{
			print "I'm afraid you can't do that.  Please try another action.";
		}

	}

	elsif ( ($VerbIn eq "giv" ) )	# GIVE ITEM TO ITEM code
	{
		if (!($aretwoitems)) 
		{

			print "Give @$items[0] to whom / what?  Please retry command.";
		}
		elsif( ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) and $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum2) )
		{
			my $sendtoitemcode = $VerbIn.$ObjectNum2;
			if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
			{
				print "Nothing happened.\n";
			}
		}
		else
		{
			print "I'm afraid you can't do that.  Please try another action.";
		}

	}	# End elsif GIVE command

	elsif ( $VerbIn eq "put" )		# PUT ITEM IN/ON ITEM code
	{
		if( !($aretwoitems) )
		{
			print "Put @$items[0] on/in what?  Please retry command.";
		}
		elsif (($Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) and  ( $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum2) or $Player->CheckIfItem($ObjectNum2) ))
		{
			my $sendtoitemcode = $VerbIn.$ObjectNum2;
			if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
			{
				print "Nothing happened.\n";
			}
		}
		else
		{
			print "I'm afraid you can't do that.  Please try another action.";
		}
	}		# End elsif PUT command

	else 		# this else requires that we have gotten a returncode from the extra actions list
	{
		if( !($aretwoitems) )
		{
			print "I'm not sure how to do that.  Please retry command.";
		}
		elsif (($Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) and  ( $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum2) or $Player->CheckIfItem($ObjectNum2) ))
		{
			my $sendtoitemcode = $VerbIn.$ObjectNum2;
			if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
			{
				print "Nothing happened.\n";
			}
		}
		else
		{
			print "I'm afraid you can't do that.  Please try another action.";
		}
	}		# End elsif PUT command


	return;
}	# End ExecuteVerbCode2

# EXECUTEVERBCODE1($VERBCODE, $OBJECTLIST) - Actually performs the actions specified by the input VERBCODE and list of objects
#
sub ExecuteVerbCode1
{
	
	my $VerbIn = shift;
	my $items = shift;
	my $thang;
	my @templist;


	#  Following code block deals with "DROP ALL" command
	if ( (@$items[0] eq "all") and ($VerbIn eq "dr") )
	{
		my $numplayeritems;
		my @Inames = $Player->GetInvNames();
		$numplayeritems = scalar(@Inames);
		for ($thang=0;$thang<$numplayeritems; $thang++) 
		{
			@templist[0] = $Inames[$thang];
			&ExecuteVerbCode1("dr", \@templist);
		}
		return;
	}
	# End code block for "DROP ALL" command


	#  Following code block deals with "GET ALL" command
	#  Only attempts to GET items that are viewable for the inventory list of a room
	if ( (@$items[0] eq "all") and ($VerbIn eq "g") )
	{
		my $numroomitems;
		my @Inames = $AllRooms[$ActiveRoom]->GetInvNames();
		$numroomitems = scalar(@Inames);
		for ($thang=0;$thang<$numroomitems; $thang++) 
		{
			@templist[0] = $Inames[$thang];
			my $ItemNum1 = $ItemtoNumHash{$Inames[$thang]};
			if ($ItemList[$ItemNum1]->GetShowInInv())
			{
				&ExecuteVerbCode1("g", \@templist);
			}
			
		}
		return;
	}
	# End code block for "GET ALL" command


	my $ObjectNum1;		# The translation of the item name to it's entry in ItemList from ItemtoNumHash

	if (scalar(@$items) eq 0) 
	{
		print "\nYou are unable to do that right now.  Please try something else.\n";
	}

	else	# If request has been formatted correctly (commandline consisted of Verb and object)
	{
		$ObjectNum1 = $ItemtoNumHash{@$items[0]};
		if( ($VerbIn eq 'dr') )		# This is the "DROP ITEM" code
		{
			if($Player->RemoveFromInv($ObjectNum1) )
			{
				$AllRooms[$ActiveRoom]->AddToInv($ObjectNum1);
				print "You have dropped the $ItemList[$ObjectNum1]->{ItemName}.\n";
			}
			else { print "I'm afraid that you cannot drop this item.\n"; }
		}	# End DROP Code

		elsif( ($VerbIn eq 'g') )	# This is the "GET ITEM" code
		{
			if($AllRooms[$ActiveRoom]->RemoveFromInv($ObjectNum1))
			{
				if ( ($ItemList[$ObjectNum1]->GetCanBeTaken()) and ($Player->AddToInv($ObjectNum1) ) )	# If we are overly encumbered, etc...
				{
					$ItemList[$ObjectNum1]->ExecuteSwitch($VerbIn."00");	# In case when the item is taken, any game changes
																				# have to be made
					print "You have taken the ", @$items[0], "\n";
					return;
				}
				else 
				{ 
					print "I'm afraid that you cannot pick up the @$items[0].\n"; 
					$AllRooms[$ActiveRoom]->AddToInv($ObjectNum1);
				}
			}
			else { print "I'm afraid that you cannot pick this item up.\n"; }
		}	# End GET code

		elsif ($VerbIn eq 'l')	 # This is the look at item code
		{
			if ( $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) or $Player->CheckIfItem($ObjectNum1) ) 
			{
				$ItemList[$ObjectNum1]->ExecuteSwitch($VerbIn."00");	# We can execute switches on look commands!  Huge!
				my $outstr = @ItemList[$ObjectNum1]->GetDesc();
				kenprint(&FormatString($outstr));
			}
			else	# if item is not in possesion or room
			{
				print "You can't look at something that isn't here.\n";
			}
		}	# End LOOK Code

		elsif ($VerbIn eq 'm')	# Move Item code.  Itemswitch m00 is a generic move item.  m# is move item to item #
		{
			if ( $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) or $Player->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "The $ItemList[$ObjectNum1]->{ItemName} cannot be moved.\n";
				}
			}
			else	# if the item is not in the players possesion OR in the room
			{
				print "I'm afraid that you can't move something that is not here.\n";
			}
		}	# End MOVE Code

		elsif ($VerbIn eq 'lt')
		{
			if ($Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1)) 
			{
				my $sendtoitemcode = $VerbIn."00";
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "The $ItemList[$ObjectNum1]->{ItemName} cannot be lit.\n";
				}
			}
			else 
			{
				my $outstr =  "I'm afraid you are nowhere near that item, and therefore cannot light it.\n";
				kenprint(&FormatString($outstr));
			}
		}	# End LIGHT code

		elsif ($VerbIn eq 'use')
		{
			if ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "You try to use the $ItemList[$ObjectNum1]->{ItemName}, but nothing happens.";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	# End USE code

		elsif ($VerbIn eq 'clo')		# Close item
		{
			if ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";;
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "The $ItemList[$ObjectNum1]->{ItemName} cannot be closed.\n";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	# End CLOSE code

		elsif ($VerbIn eq 'eat')		# Eat item
		{
			if ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";;
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "You cannot eat the $ItemList[$ObjectNum1]->{ItemName}.\n";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	# End EAT code

		elsif ($VerbIn eq 'drn')		# Eat item
		{
			if ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";;
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "You cannot drink the $ItemList[$ObjectNum1]->{ItemName}.\n";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	# End DRINK code

		elsif ($VerbIn eq 'prs')		# Press item
		{
			if ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";;
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "You press on the $ItemList[$ObjectNum1]->{ItemName}, but nothing happens.\n";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	# End PRESS code

		elsif ($VerbIn eq "rea")		# Read item
		{
			if ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";;
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "The $ItemList[$ObjectNum1]->{ItemName} cannot be read.\n";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	# End READ code




		elsif ($VerbIn eq 'ope')		# Open item 
		{
			if ($AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";	# No object needs be specified
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "You are unable to open the $ItemList[$ObjectNum1]->{ItemName}.\n";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	

		else  # If the verbcode is a value in the expanded action hash...
		{
			if ($AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) ) 
			{
				my $sendtoitemcode = $VerbIn."00";	# No object needs be specified
				if (! ($ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode))) 
				{
					print "You are unable to perform that action right now.\n";
				}
			}
			else
			{
				print "You cannot do that here.";
			}
		}	# End main ELSE structure



	return;
}	# End ExecuteVerbCode1





# GETITEMSFROMCOMMAND(@cline) - steps through @CLINE and finds all of the items that are referenced therein
#											Returns a list of items, in the order they are refenced.
sub GetItemsFromCommand
{
	$cline = shift;

	my @returnlist;
	my @itemkeys = keys(%ItemtoNumHash);
	my $thang;
	my $wordincline;
	my $lowerword;

	if (@$cline[0] eq "all")		# Special case of items
	{
		push(@returnlist, "all");
		return @returnlist;
	}

	if (@$cline[0] eq "typetype")	# A special case of the action:  There will only be one item and then a bunch of text
	{								# For "write" and "type" actions, etc
		foreach $wordincline (@$cline) 
		{
			$lowerword = $wordincline;
			$lowerword =~ tr/[A-Z]/[a-z]/;
			foreach $thang (@itemkeys) 
			{
				$lowerthang = $thang;
				$lowerthang =~ tr/[A-Z]/[a-z]/;
				if ($lowerthang eq $lowerword) 
				{
					push(@returnlist, $thang);
					return @returnlist;
				}
			}
		}
	}

	my $index = 0;
	#print "The first word in cline is @$cline[0]\n";
	#  This code block goes through each word in the input command line, and checks to see which, if any, words in the input
	#	correspond to items in the object list.  If so, it pushes it onto the item list to be returned
	foreach $wordincline (@$cline) 
	{

		$index++;

		$low_wordincline = $wordincline;
 		$low_wordincline =~ tr/[A-Z]/[a-z]/;

		$low_doublewordincline = $wordincline." ".@$cline[$index];
		$low_doublewordincline =~ tr/[A-Z]/[a-z]/;

		# foreach loop looks at every item in ITEMKEYS and checks it against each word and word pair in CLINE
		foreach $iteminkeys (@itemkeys) 
		{
			$low_iteminkeys = $iteminkeys;
			$low_iteminkeys =~ tr/[A-Z]/[a-z]/;
			if ($low_wordincline eq $low_iteminkeys) 
			{
				push(@returnlist, $iteminkeys);
				#print $iteminkeys, "\n";
				#return @returnlist;
				last;
			}
			if ($low_doublewordincline eq $low_iteminkeys) 
			{
				push(@returnlist, $iteminkeys);
				#print $iteminkeys, "\n";
				return @returnlist;
				last;
			}

			# Next code block maybe should take care of some of the aliasing?
			@SplitItemInKeys = split(/ /, $low_iteminkeys);
			if (scalar(@SplitItemInKeys) eq 2) 
			{
				if ($low_wordincline eq $SplitItemInKeys[1]) 
				{
					push(@returnlist, $iteminkeys);
					return @returnlist;
					last;
				}
			}
			
		}

	}

	return @returnlist;
}

# Quick kill for the game, with goodbye message
sub KillGame
{
	print "\nThank you for playing!\n";
	exit;
}

# LOOKATROOM()
#
#	Prints the description of the current room, including a listing of all viewable items in room
sub LookAtRoom
{

	my $outstr;

	if ($AllRooms[$ActiveRoom]->{ShowRoomName}) 
	{
		print $AllRooms[$ActiveRoom]->{RoomName}, "\n";
	}
	

	if ( !($AllRooms[$ActiveRoom]->{BeenSeen}) )
	{
		$outstr =  @AllRooms[$ActiveRoom]->GetDesc()."\n";
		kenprint(&FormatString($outstr));
	}

	if ($AllRooms[$ActiveRoom]->{ShowRoomName}) 
	{
		my $thang;
		my $youseeswitch = 1;		# a switch to make sure we only write "In the room you see" a single time
		$numitems = $AllRooms[$ActiveRoom]->{Inv}[0];
		if($numitems)
		{
			
			my @ilist = $AllRooms[$ActiveRoom]->GetItemList();
			foreach $thang (@ilist) 
			{
				if ($ItemList[$thang]->GetShowInInv())			# Is the item something we want to show in a inventory listing of the room?
				{	
					if ($youseeswitch) 
					{
						print "In the room, you see:\n";
						$youseeswitch = 0;
					}				
					print " ", $ItemList[$thang]->{ItemName}, "\n";
				}
			}	
			print "\n";
		}	
	}
	$AllRooms[$ActiveRoom]->{ShowRoomName} = 0;
	return;
}	# End LOOKATROOM()

# DECODEVERB($verb) - Returns the proper code to be implemented (if any) for the verb scalar supplied thereto.
#
# Return values are coded in a particular way.  They each begin with a number [0, 2].  This signifies the number of 
#	objects that the action must operate on.  
#				0 signifies that there are no objects other than the player involved (eg "north")
#				1 signifies that the action operates / relates to a single object / item  (eg "drop sword")
#				2 signifies that the action relates to two objects / items (eg "put sword in sheath")
# After the number is a character sequence which signifies the action to be taken
#
# List of Return Codes (just the portion after the leading #):
# (-1, n, s, e, w, u, d, q, l, dr, g, inv, lt, m, use, giv, put, ope, clo, eat, drn, prs, hug, rea, typ, wrt -2,  )
sub DecodeVerb
{
	my $VerbIn = shift;
	my $sline = shift;

	my @t = @$sline;

	if ( ($VerbIn eq 'go') )	# "go" should be immediately followed by a direction
	{
		return -1;	# -1 is the repeat code for the do until loop that calls this method:
					#  Tells the calling function that the next word in the command line should be a direction
	}	# End ELSIF for	GO
	elsif ( ($VerbIn eq 'n') or ($VerbIn eq 'north')) 
	{
		return "0n";
	}	# End ELSIF for north

	elsif ( ($VerbIn eq 's') or ($VerbIn eq 'south'))
	{
		return "0s";
	}	# End ELSIF for south

	elsif ( ($VerbIn eq 'e') or ($VerbIn eq 'east'))
	{
		return "0e";
	}	# End ELSIF for east

	elsif ( ($VerbIn eq 'w') or ($VerbIn eq 'west'))
	{
		return "0w";
	}	# End ELSIF for west

	elsif ( ($VerbIn eq 'u') or ($VerbIn eq 'up'))
	{
		return "0u";
	}	# End ELSIF for up

	elsif ( ($VerbIn eq 'd') or ($VerbIn eq 'down'))
	{
		return "0d";
	}	# End ELSIF for down

	elsif ( ($VerbIn eq 'quit') or ($VerbIn eq 'q') or ($VerbIn eq 'exit'))
	{
		return "0q";
	}	# End ELSIF for quit

	elsif ( ($VerbIn eq "look") or ($VerbIn eq "l") )
	{
		
		if( scalar(@$sline) eq 0)
		{
			return "0l";	# That's 0L
		}
		else
		{
			return "1l";	# That's (ONE)L
		}
	}	# End ELSIF for Look

	elsif ( ($VerbIn eq 'inv') or ($VerbIn eq 'i') or ($VerbIn eq 'inventory') )
	{
		return "0inv";
	}	# End ELSIF for Inventory

	elsif ( ($VerbIn eq "drop") )
	{
		return "1dr";
	}

	elsif ( ($VerbIn eq "get") or ($VerbIn eq "take") )
	{
		return "1g";
	}

	elsif ( ($VerbIn eq "light") )
	{
		return "1lt";	# That's (ONE)LT
	}

	elsif ( ($VerbIn eq "move") )	#  "Move" operates on items  (move boulder, etc)
	{
		my @temp = @$sline;
		my @tempitems = &GetItemsFromCommand(\@temp);
#		if ( (scalar(&GetItemsFromCommand(\@$sline)) eq 1) and (scalar(@$sline) eq 1) ) 
		if ( (scalar(@tempitems) eq 1)  ) # I don't remember why the scalar(sline) line is there, so I'll just com it out
		{
			return "1m";
		}
		else 
		{
			return "2m"; 
		}
	}

	elsif ( ($VerbIn eq "use") )
	{
		my @temp = @$sline;
		my @tempitems = &GetItemsFromCommand(\@temp);
#		if ( (scalar(&GetItemsFromCommand(\@$sline)) eq 1) and (scalar(@$sline) eq 1) ) 
		if ( (scalar(@tempitems) eq 1)  ) # I don't remember why the scalar(sline) line is there, so I'll just com it out

		{
			return "1use";
		}
		else 
		{
			return "2use"; 
		}
	}

	elsif ( ($VerbIn eq "put") )
	{
		return "2put";
	}

	elsif ( ($VerbIn eq "give") )
	{
		return "2giv";
	}
	
	elsif ($VerbIn eq "open")

	{
		return "1ope";
	}

	elsif ($VerbIn eq "close")
	{
		return "1clo";
	}
	
	elsif ($VerbIn eq "eat")
	{
		return "1eat";
	}

	elsif ($VerbIn eq "drink")
	{
		return "1drn";
	}

	elsif ($VerbIn eq "huge")
	{
		return "0hug";
	}

	elsif ($VerbIn eq "read")
	{
		return "1rea";
	}

	elsif (($VerbIn eq "press") or ($VerbIn eq "push") or ($VerbIn eq "pull"))
	{
		return "1prs";
	}

	elsif ($VerbIn eq "type")
	{
		return "ttyp";
	}

	elsif ($VerbIn eq "write")
	{
		return "twrt";
	}

	elsif ($VerbIn eq "say")
	{
		return "tsay";
	}

	elsif ($VerbIn eq "again")
	{
		&ParseCommand($lastcommand);
		return "-3";
	}

	elsif ($VerbIn eq "save")
	{
		&GameSaveWrite();
		return "-3";
	}

	elsif ($VerbIn eq "load")
	{
		if (&GameSaveLoad()) 
		{
			return "-3";
		}
		else 
		{
			print "Could not load game\n";
			return "-3";
		}
	}

	elsif ($returncode = $ActiontoSwitchHash{$VerbIn})
	{
		return $returncode;
	}

	else 
	{
		return "-2";		# -2 is the killcode:  Uncomprehensible command
	}

}	#End DecodeVerb

#	EXECUTEVERBCODE0($VerbCode) - Takes a VerbCode, and implements the action the verbcode requests
#
#		Takes verbcodes from two sources:  Input commands which have do direct object are shunted to this 
sub ExecuteVerbCode0
{

	my $vcode = shift;


	if ($vcode eq 'n') 
	{
		if ( !($AllRooms[$ActiveRoom]->{North}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1) )
		{
			$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
			$ActiveRoom = $AllRooms[$ActiveRoom]->{North}[$AllRooms[$ActiveRoom]->{ActiveState}];
		}
		elsif ($AllRooms[$ActiveRoom]->{North}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1)
		{
			print "I'm afraid you cannot move north from this room.\n";
		}
	} elsif ($vcode eq 's')
	{
		if (!($AllRooms[$ActiveRoom]->{South}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1) )
		{
			$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
			$ActiveRoom = $AllRooms[$ActiveRoom]->{South}[$AllRooms[$ActiveRoom]->{ActiveState}];
		}
		elsif ($AllRooms[$ActiveRoom]->{South}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1)
		{
			print "I'm afraid you cannot move south from this room.\n";
		}
	} elsif ($vcode eq 'e')
	{
		if (!($AllRooms[$ActiveRoom]->{East}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1) )
		{
			$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
			$ActiveRoom = $AllRooms[$ActiveRoom]->{East}[$AllRooms[$ActiveRoom]->{ActiveState}];
		}
		elsif ($AllRooms[$ActiveRoom]->{East}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1)
		{
			print "I'm afraid you cannot move east from this room.\n";
		}
	} elsif ($vcode eq 'w')
	{
		if (!($AllRooms[$ActiveRoom]->{West}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1) )
		{
			$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
			$ActiveRoom = $AllRooms[$ActiveRoom]->{West}[$AllRooms[$ActiveRoom]->{ActiveState}];
		}
		elsif ($AllRooms[$ActiveRoom]->{West}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1)
		{
			print "I'm afraid you cannot move west from this room.\n";
		}
	} elsif ($vcode eq 'u')
	{
		if (!($AllRooms[$ActiveRoom]->{Up}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1) )
		{
			$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
			$ActiveRoom = $AllRooms[$ActiveRoom]->{Up}[$AllRooms[$ActiveRoom]->{ActiveState}];
		}
		elsif ($AllRooms[$ActiveRoom]->{Up}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1)
		{
			print "I'm afraid you cannot move up from this room.\n";
		}
	} elsif ($vcode eq 'd')
	{
		if (!($AllRooms[$ActiveRoom]->{Down}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1) )
		{
			$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
			$ActiveRoom = $AllRooms[$ActiveRoom]->{Down}[$AllRooms[$ActiveRoom]->{ActiveState}];
		}
		elsif ($AllRooms[$ActiveRoom]->{Down}[$AllRooms[$ActiveRoom]->{ActiveState}] eq -1)
		{
			print "I'm afraid you cannot move down from this room.\n";
		}
	} elsif ($vcode eq 'l')
	{
		$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
		$AllRooms[$ActiveRoom]->{BeenSeen} = 0;		#  We don't have to call LookAtRoom because it's automatically called
													#	each time the command prompt comes around.  So we just have to tell it
													#	to show the description next time it cycles.
	} elsif ($vcode eq 'q')
	{
		&KillGame();
	} elsif ($vcode eq "inv")
	{
		$Player->ShowInv();
	}

	elsif ($vcode eq "hug")
	{
		print "Huge indeed\n";
	}

	return;
}


#	EXECUTEVERBCODET($VERBIN, $OBJECTIN, @COMMANDLINE)
sub ExecuteVerbCodeT
{

	$verbin = shift;
	$objectin = shift;
	$CommandLine = shift;   #(Access by \@CommandLine)

	@temp = @$CommandLine;
	if ($objectin eq "no item") 
	{
		$objectin = "SpeechItem";
		@temp;
		unshift(@temp, $objectin);
	}

	$ObjectNum1 = $ItemtoNumHash{$objectin};

	if ( $Player->CheckIfItem($ObjectNum1) or $AllRooms[$ActiveRoom]->CheckIfItem($ObjectNum1) or $objectin eq "SpeechItem") 
		{
			
			
			$rebuilt = undef;

			# What we want to do here is rebuild a scalar with everything from the command line following the item ($OBJECTIN)
			#	We then want to check this rebuilt line against a comment.  If it matches a comment, then we build a code and send that
			#	code the ExecuteSwitch method of the input object.  Trivial.  huge.  Boot.
			$i = 0;		# Will be the index of $OBJECTIN in @COMMANDLINE


			$objectin =~ tr/[A-Z]/[a-z]/;		#	Make Objectname lowercase
			foreach $thang (@temp) 
			{
				# Next kludgy code block pushes the index to the point after the item name
				my @t;
				push(@t, $thang);				
				@y = GetItemsFromCommand(\@t);
				
				if (scalar(@y) > 0) 
				{
					last;
				}
				$i++;
			}

			for ($into_temp = 1;$into_temp<=$i+1 ; $into_temp++) 
			{
				shift(@temp);
			}

			@SplitItemName = split(/\s+/, $y[0]);


			foreach $thang (@temp) 
			{
				$rebuilt = $rebuilt.$thang." ";
			}

			$_ = ' ';
			chop($rebuilt);
			$_ = '\n';
			
			my $index = 0;
			my $sendtoitemcode;
			foreach $temp (@CommentList) 
			{
				$thang = $temp;
				$thang =~ tr/[A-Z]/[a-z]/;
				if ($rebuilt eq $thang) 
				{
					$sendtoitemcode = $verbin.$index;		
				}
				$index++;
			}
			$ItemList[$ObjectNum1]->ExecuteSwitch($sendtoitemcode);
		} # End IF items are in inv or room's inv

		else 
		{
			print "\nI'm afraid you can't do that.  Item is not available.";
			Exit;
		}


}	# End ExecuteverbCodeT


#	EXECUTEVERBCODEI($VCodeFromItemObject) - Takes in a result switchcode from an item object, and implements the action
#	said switchcode requests
#
sub ExecuteVerbCodeI
{
	my $Scode = shift;


	if ($Scode =~ /^[0-2]/)	# If the switchcode corrresponds to a "regular" command line action (eg go north, look, etc)
	{
		if ($Scode =~ /^0/) 
		{
			$Scode =~ s/^0//;				#	Strip preceding digit from code
			ExecuteVerbCode0($Scode);
		}
		elsif ($Scode =~ /^1/)
		{
			my @ObjectList;
			$Scode =~ s/^1//;				#	Strip preceding digit from code
			my $alphacode = $Scode;
			my $numcode = $Scode;
			$alphacode =~ s/[0-9]//gi;		#	$ALPHACODE is the alphabetic portion of the code
			$numcode =~ s/[a-z]//gi;		#	$NUMCODE is the numeric portion of the code (has to be decoded to an item)
											#   The gi switches on the end are "Global case-Insensitive"

			push(@ObjectList, @ItemList[$numcode]->{ItemName});	# Pushes the name of the item onto the @ObjectList list
			&ExecuteVerbCode1($alphacode, \@ObjectList);
		}
		else	# if the Scode begins with a "2"
		{
			my @ObjectList;
			my @NumList;
			$Scode =~ s/^2//;
			my $alphacode = $Scode;
			$alphacode =~ s/[^a-z]//gi;		# Strip any character that is not an alphabetic one, global and insensitive
			$Scode =~ s/[a-z]//gi;			# Strip any character that is an alphabetic one, global and insensitive
			@NumList = split(/\-/, $Scode);
			foreach $num (@NumList) 
			{
				push(@ObjectList, @ItemList[$num]);
			}

			&ExecuteVerbCode2($alphacode, \@ObjectList);
		}	# End if/elsif/else foe each preceding digit case

	}	# End IF $Scode has leading digit [0-2]

	else	#	Here will be the cases for all actions that cannot / aren't CommandLine-type actions
	{
		
		if ($Scode =~ /^str/)	# The Send to Room code:  Sends player to a particular room (like a transporter button)
		{
			$AllRooms[$ActiveRoom]->{ShowRoomName} = 1;
			$Scode =~ s/str//;		# Removes "str" from the beginning of the Scode
			$ActiveRoom = $Scode;	# The only thing left in the $Scode should be the room number the adventurer is being sent to
		}

		elsif ($Scode =~/^cr/)	# ChangeRoomState Code:  switches the active state of a room
								#	TODO:  Add code to this which will pick up the "toggle switch"-type switchcode
								#			i.e. cr4-0/1/2/3 will switch from states 0 to 1 to 2 to 3...
		{
			$Scode =~s/cr//;	# Removes "cr" from the beginning of the Scode
			my @numlist = split(/\-/, $Scode);
			my $RoomToChange = @numlist[0];
			my $newstate = @numlist[1];
			$AllRooms[$RoomToChange]->{ActiveState} = $newstate;
			$AllRooms[$RoomToChange]->{BeenSeen} = 0;
		}

		elsif ($Scode =~/^cis/)	# ChangeItemState Code
		{
			$Scode =~s/cis//;
			my @numlist = split(/\-/, $Scode);
			my $ItemToChange = $numlist[0];
			my $newstate = @numlist[1];
			$ItemList[$ItemToChange]->ChangeActiveState($newstate);
		}

		elsif ($Scode =~/^rifr/)	# RemoveItemFromRoom code:  Does nothing if item is not in room specified
									#  If the room specified is "Z", removes item from the current ActiveRoom (used in conjunction
									#	with a "player drop" switch)
		{
			$Scode =~ s/rifr//;
			my @numlist = split(/\-/, $Scode);
			my $ItemToRemove = $numlist[0];
			my $RoomToChange = $numlist[1];
			if ($RoomToChange  = "Z") 
			{
				$AllRooms[$ActiveRoom]->RemoveFromInv($ItemToRemove);
				return 1;
			}
			
			if ($AllRooms[$RoomToChange]->CheckIfItem($ItemToRemove) ) 
			{
				$AllRooms[$RoomToChange]->RemoveFromInv($ItemToRemove);				
			}


		}

		elsif ($Scode =~/^pd/)	# PlayerDrop code:  If item specified is in players inventory, drops the item (use in conjunction 
								#	remove item switch). 
		{
			$Scode =~ s/pd//;
			my $ItemToRemove = $Scode;
			if ($Player->CheckIfItem($ItemToRemove) )
			{
				$Player->RemoveFromInv($ItemToRemove);
				$AllRooms[$ActiveRoom]->AddToInv($ItemToRemove);
			}
		}

		elsif ($Scode =~/^aitr/)	# AddItemToRoom code
									#  If the room specified is "Z", adds item to the current ActiveRoom 
		{
			$Scode =~ s/aitr//;
			my @numlist = split(/\-/, $Scode);
			my $ItemToAdd = $numlist[0];
			my $RoomToChange = $numlist[1];
			if ($RoomToChange eq 'Z') 
			{
				$AllRooms[$ActiveRoom]->AddToInv($ItemToAdd);
				return 1;
			}
			$AllRooms[$RoomToChange]->AddToInv($ItemToAdd);
			
		}

		elsif ($Scode =~ /^cir/)	# CheckIfInRoom Code:  Returns zero if the player is not in the specified room
									#   eg: cir3 returns true if the ActiveRoom is 3, zero / false otherwise
									#	Returning a zero means that the switchcodes following this one will not be executed.
		{
			$Scode =~ s/cir//;
			my $RoomToCheck = $Scode;	#The only thing left in Scode should be the number of the room
			if ($ActiveRoom eq $RoomToCheck) 
			{
				return 1;
			}
			return 0;
		}

		elsif ($Scode =~/^csr/)		# CheckStateofRoom Code:  Returns zero if the specified room is not in the specified state:
									#	eg:  csr3-2 returns true if Room 3 is in state 2, zero otherwise
									#	Returning a zero means that the switchcodes following this one will not be executed.
		{
			$Scode =~ s/csr//;
			my @numlist = split(/\-/, $Scode);
			my $RoomToCheck = $numlist[0];
			my $State = $numlist[1];
			if ( !($AllRooms[$RoomToCheck]->{ActiveState} eq $State) ) 
			{
				return 0;
			}
		}

		elsif ($Scode =~/^csi/)		# CheckStateofItem Code:  Returns zero if the specified item is not in the specified state:
		{
			$Scode =~ s/csi//;
			my @numlist = split(/\-/, $Scode);
			my $ItemToCheck = $numlist[0];
			my $State = $numlist[1];
			if ( !($ItemList[$ItemToCheck]->{ActiveState} eq $State) ) 
			{
				return 0;
			}
		}

		elsif ($Scode =~/^cif/)		# CheckIfItem Code: Checks to see if the item is in the players inventory
		{
			$Scode =~ s/cif//;
			my $itemcheck = $Scode;
			if (! ($Player->CheckIfItem($itemcheck) ) )
			{
				return 0;
			}
		}

		elsif ($Scode =~/^pc/)		# PrintComment Code:  Prints to screen the comment specified in the switchcode
		{
			$Scode =~ s/^pc//;
			my $outstr = $CommentList[$Scode]."\n\n";
			kenprint(&FormatString($outstr));
		}

	}	# End else

	
return 1;

}	# End ExecuteVerbCodeI method



#GAMESAVEWRITE will generate a list of the switchcodes that will put the game in a state in an
#	earlier session.  Takes $filename, the filename of the savegame to load.
sub GameSaveWrite
	{
		
		$outstr = "What filename do you want to save under?  (your name would be a fair choice)\n";
		kenprint(&FormatString($outstr));
		print ">> ";
		$filename = <STDIN>;
		chomp($filename);
		$filename = $filename.".sav";

		open SAVEDGAME, ">$filename" or die "File could not be saved\n";
		
		print SAVEDGAME "$gamename\n";
		
		# We have to go through each room, item, and player inventory.  Sux.
		for ($IndexToRooms = 0; $IndexToRooms<$numrooms; $IndexToRooms++) 
		{
			$activestate = $AllRooms[$IndexToRooms]->{ActiveState};
			print SAVEDGAME "cr$IndexToRooms-$activestate\n";

			
			$RoomItemScalar = $AllRooms[$IndexToRooms]->ReturnItemVector();
			
			if (!($RoomItemScalar eq "-1") )	# If $RoomItemScalar eq -1, then there are no items in that room.
			{
				my @RoomsItemList = split(/\-/, $RoomItemScalar);
				foreach $item (@RoomsItemList) 
				{
						# If the room doesn't already contain the item, add it
						if (!($AllRooms[$IndexToRooms]->CheckIfItem($item) ) )
						{
							print SAVEDGAME "aitr$item-$IndexToRooms\n";
						}
						
			
				}
			}
		}	# That should do it for the Rooms.  Now the item states.

		$numitems =  scalar(@ItemList);
		for ($IndexToItems = 0; $IndexToItems<$numitems; $IndexToItems++) 
		{
			$activestate = $ItemList[$IndexToItems]->{ActiveState};
			print SAVEDGAME "cis$IndexToItems-$activestate\n";
		}	# That should be it for the items.

		# We have to worry about the players inventory, and the room he's in in the game.
		@PlayersItemList = $Player->{Inv};
		
		$PlayerItemScalar = $Player->ReturnItemVector();
		if (!($PlayerItemScalar eq "-1") )	# If $PlayerItemScalar eq -1, then there are no items in that room.
		{
			my @PlayerItemList = split(/\-/, $PlayerItemScalar);
			foreach $item (@PlayerItemList) 
			{
					print SAVEDGAME "aitr$item-Z\n";
					print SAVEDGAME "1g$item\n";
		
			}


		}  # And that should be everything

		# Player has to be in a particular room...  Send him there.
		print SAVEDGAME "str$ActiveRoom\n";

		print "Game saved under filename \"$filename\"\n";
		close SAVEDGAME;
		

	}	# End GAMESAVEWRITE


sub GameSaveLoad
	{

		$outstr = "What file do you want to load?\n";
		kenprint(&FormatString($outstr));
		print ">> ";
		$filename = <STDIN>;
		chomp($filename);
		if (! ($filename =~/$".sav"/) )  # If the entered file doesn't end in .sav, add it.
		{
			$filename = $filename.".sav";
		}

		open LOADGAME, $filename or return 0;
		@AllSwitches = <LOADGAME>;
		chomp(@AllSwitches);
		if (!($AllSwitches[0] eq $gamename) )
		{
			print "Savegame does not match game resident in memory.\n";
			return 0;
		}
		else
		{
			shift(@AllSwitches);
			foreach $switch (@AllSwitches) 
			{
				print "$switch\n";
				&ExecuteVerbCodeI($switch);
			}
		}
	close LOADGAME;
	print "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nGame \"$filename\" loaded\n";
	&ExecuteVerbCodeI("0l");
	return 1;
	}

}
