#    Amazing Text Fun Game Engine - a engine for the decoding and play of .atf game files
#    Copyright (C) <2002>  <Kenneth Bromberg, Antoni Chan>
#    See README for full license information

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	Questions or comments?  Contact the author - atfengine@alltooflat.com

package Person;

#TODO :		Maybe make another inventory-type structure that is what the player is wearing?
#			Code system for beginning inventory?  or maybe just put everything in beginning inventory in starting room?			
sub new
{
	my $Class = shift;
	my $self = {};	#Makes anonymous hash SELF
	$self->{Score} = 0;
	$self->{Inv} = [0];				# A list of Item reference numbers that the character is currently holding
	$self->{InvWeight} = 0;
	$self->{Money} = 0;				# ?
	$self->{MaxWeight} = 100;		# The maximum weight that the player can carry.  For a game, if encumberence is to be ignored
									#  all item weights should be zero.

	bless $self, $Class;
	
}


sub AddtoScore
{
	my $self = shift;
	$self->{Score} = $self->{Score} + shift;
}

#	ADDTOINV($) 
# TODO: Must be changed to add Inventory Weight change and check
sub AddToInv
{
	my $self = shift;


	
	$self->{Inv}[0]++;
	$self->{Inv}[$self->{Inv}[0]] =  shift;

	return 1;
}

# REMOVEFROMINV($ITEMTOREMOVE) - Checks for and removes an item from the player inventory
#
#	Takes as an argument an item reference number.
#	Returns 1 if successful, 0 if unsuccessful (ie player is not holding item)
sub RemoveFromInv
{

	my $self = shift;
	my $ItemtoRem = shift;

	if ($itemplace = $self->CheckIfItem($ItemtoRem)) 
	{
			$self->{Inv}[$itemplace] = $self->{Inv}[$self->{Inv}[0]];
			$self->{Inv}[0]--;
			return 1;
	}
	else 
	{ 
		print "\nItem is not in inventory.\n";
		return 0;
	}
}


# CHECKIFITEM($ITEMTOREMOVE) - Searches the player inventory for a particular item.
#
#	Takes as an argument an item reference number
#	Returns 0 if the item is not in the inventory.
#	Returns the index of the item in the inventory if it is in inventory
sub CheckIfItem
{
	my $self = shift;
	my $ItemtoRem = shift;

	for ($i = 1; $i <= $self->{Inv}[0] ; $i++) 
	{
		if ($self->{Inv}[$i] eq $ItemtoRem) 
		{
			return $i;
		}
	}
	return 0;
}


sub ShowInv
{
	my $self = shift;
	my $tempitem;

	if ($self->{Inv}[0] eq 0) {
		print "You have no items.\n";
	}
	else 
	{	print "You are carrying:\n";
		for ($index = 1; $index <= $self->{Inv}[0]; $index++) 
		{
			$tempitem =  $self->{Inv}[$index];
			print $Main::ItemList[$tempitem]->{ItemName}, "\n";
		}
	}
	print "\n";
}


#  GETINVNAMES() - Returns a list of items the player character is currently carrying (the item names, not ref numbers)
#
#	Mostly for use by the action package and the "All" switch on drop commands
sub GetInvNames
{
	my $self = shift;
	my $thang;
	my @returnlist;

	for ($thang = 1; $thang <= $self->{Inv}[0]; $thang++) 
	{
		my $actualitem = $self->{Inv}[$thang];
		push(@returnlist, $Main::ItemList[$actualitem]->{ItemName});
	}

	return @returnlist;
}	# End GETINVNAMES


sub ShowStatus
{
	my $self = shift;

	print "\n";
	print "You are alive.\nYou have ", $self->{Score}, " points\n";
	print "You are holding:\n";
	$self->ShowInv();
	print "\n\n";
}


#	This function returns a scalar value:  -1 if the room holds no items
#											a list of item numbers seperated by "-"'s if the player is holding items.
sub ReturnItemVector
{
	my $self = shift;

	$ScalarToReturn = "";
	if ($self->{Inv}[0] eq 0) 
	{
		$ScalarToReturn = "-1";
	}
	else
	{
		for ($index = 1; $index <= $self->{Inv}[0]; $index++) 
		{
			$ScalarToReturn = $self->{Inv}[$index]."-".$ScalarToReturn;
		}
		chop($ScalarToReturn);
	}

	return $ScalarToReturn;
}


sub DESTROY
{
}

1;